# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without maven
%bcond_with gcj_support
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/apache-%{base_name}/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirres %{repodir}/resources
%define repodirsrc %{repodir}/src

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define base_name       dbcp
%define short_name      commons-%{base_name}
%define section         free

Name:           apache-commons-dbcp
Version:        1.3.0
Release:        0.r830852.1%{?dist}
Epoch:          0
Summary:        Apache Commons DataBase Pooling Package
License:        Apache Software License 
Group:          Development/Libraries/Java
Url:            http://commons.apache.org/dbcp
Source0:        http://www.apache.org/dist/commons/%{base_name}/source/%{short_name}-%{version}-src.tar.gz
# svn export -r 830852 http://svn.apache.org/repos/asf/commons/proper/dbcp/trunk commons-dbcp-1.3.0-src
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-component-info.xml
Source6:        dbcp-tomcat5-build.xml
Patch0:         apache-commons-dbcp-pom.patch

BuildRequires:  jpackage-utils >= 0:5.0.0
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.7
BuildRequires:  apache-commons-pool
BuildRequires:  apache-commons-logging
#BuildRequires:  xerces-j2
#BuildRequires:  xml-commons-jaxp-1.3-apis >= 0:1.3
BuildRequires:  junit >= 3.8.1
BuildRequires:  geronimo-genesis
BuildRequires:  geronimo-j2ee-connector-1.5-api
BuildRequires:  geronimo-txmanager
BuildRequires:  howl-logger
BuildRequires:  apache-commons-pool-tomcat5
BuildRequires:  apache-commons-collections-tomcat5
BuildRequires:  tomcat5-common-lib
BuildRequires:  jta_1_1_api
%if %with maven
BuildRequires:  apache-commons-parent >= 0:12
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
%endif
Requires(post):  /usr/sbin/update-alternatives
Requires(preun):  /usr/sbin/update-alternatives
Requires(post):    jpackage-utils >= 0:5.0.0
Requires(postun):  jpackage-utils >= 0:5.0.0
Requires:       java >= 0:1.5.0
Requires:       apache-commons-parent >= 0:12
Requires:       apache-commons-collections
Requires:       apache-commons-pool
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Provides:   hibernate_jdbc_cache = %{epoch}:%{version}-%{release}
Provides:   jakarta-%{short_name} = %{epoch}:%{version}-%{release}
Obsoletes:  jakarta-%{short_name} < %{epoch}:%{version}-%{release}
Provides:   %{short_name} = %{epoch}:%{version}-%{release}
Obsoletes:  %{short_name} < %{epoch}:%{version}-%{release}

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description
Many Jakarta projects support interaction with a relational 
database. Creating a new connection for each user can be time 
consuming (often requiring multiple seconds of clock time), 
in order to perform a database transaction that might take 
milliseconds. Opening a connection per user can be unfeasible 
in a publicly-hosted Internet application where the number of 
simultaneous users can be very large. Accordingly, developers 
often wish to share a "pool" of open connections between all 
of the application's current users. The number of users actually 
performing a request at any given time is usually a very small 
percentage of the total number of active users, and during 
request processing is the only time that a database connection 
is required. The application itself logs into the DBMS, and 
handles any user account issues internally.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java
Provides:   jakarta-%{short_name}-repolib = %{epoch}:%{version}-%{release}
Obsoletes:  jakarta-%{short_name}-repolib < %{epoch}:%{version}-%{release}
Provides:   %{short_name}-repolib = %{epoch}:%{version}-%{release}
Obsoletes:  %{short_name}-repolib < %{epoch}:%{version}-%{release}

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Provides:   jakarta-%{short_name}-javadoc = %{epoch}:%{version}-%{release}
Obsoletes:  jakarta-%{short_name}-javadoc < %{epoch}:%{version}-%{release}
Provides:   %{short_name}-javadoc = %{epoch}:%{version}-%{release}
Obsoletes:  %{short_name}-javadoc < %{epoch}:%{version}-%{release}

%description javadoc
Javadoc for %{name}.

%package tomcat5
Summary:        DBCP dependency for Tomcat5
Group:          Development/Libraries/Java
Provides:   jakarta-%{short_name}-tomcat5 = %{epoch}:%{version}-%{release}
Obsoletes:  jakarta-%{short_name}-tomcat5 < %{epoch}:%{version}-%{release}
Provides:   %{short_name}-tomcat5 = %{epoch}:%{version}-%{release}
Obsoletes:  %{short_name}-tomcat5 < %{epoch}:%{version}-%{release}

%if %{gcj_support}
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description tomcat5
DBCP dependency for Tomcat5

%if %with maven
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation
Provides:   jakarta-%{short_name}-manual = %{epoch}:%{version}-%{release}
Obsoletes:  jakarta-%{short_name}-manual < %{epoch}:%{version}-%{release}
Provides:   %{short_name}-manual = %{epoch}:%{version}-%{release}
Obsoletes:  %{short_name}-manual < %{epoch}:%{version}-%{release}

%description manual
%{summary}.
%endif

%prep
%setup -q -n %{short_name}-%{version}-src
%{__sed} -i 's/\r//' LICENSE.txt
%{__sed} -i 's/\r//' NOTICE.txt
%{__sed} -i 's/\r//' README.txt
cp %{SOURCE6} .
%{__perl} -pi \
    -e 's/\r$//g;' \
  PROPOSAL.html LICENSE.txt NOTICE.txt RELEASE-NOTES.txt
%patch0 -b .sav0
%if %with maven
cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP
%endif

%build
%if %with maven
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}
export MAVEN_OPTS="-Dmaven2.jpp.mode=true -Dmaven2.jpp.depmap.file=%{SOURCE2} -Dmaven.repo.local=${MAVEN_REPO_LOCAL}"
%{_bindir}/mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        install javadoc:javadoc
%else
export CLASSPATH=$(build-classpath jta_1_1_api jdbc-stdext xerces-j2)
ant \
        -Dbuild.sysclasspath=first \
        -Dbackport-util-concurrent.jar=$(build-classpath backport-util-concurrent) \
        -Dcommons-collections.jar=$(build-classpath commons-collections) \
        -Dcommons-logging.jar=$(build-classpath commons-logging) \
        -Dcommons-pool.jar=$(build-classpath commons-pool) \
        -Dejb-spec.jar=$(build-classpath ejb_3_0_api) \
        -Djunit.jar=$(build-classpath junit) \
        -Djta-impl.jar=$(build-classpath geronimo-transaction) \
        -Djta-spec.jar=$(build-classpath jta_1_1_api) \
        -Dnaming-common.jar=$(build-classpath tomcat5/naming-resources) \
        -Dnaming-java.jar=$(build-classpath tomcat5/naming-factory) \
        -Dxerces.jar=$(build-classpath xerces-j2) \
        -Dxml-apis.jar=$(build-classpath xml-commons-apis) \
        -Djava.io.tmpdir=. \
        dist
# test
%endif

export CLASSPATH=$(build-classpath jta_1_1_api jdbc-stdext xerces-j2 commons-collections-tomcat5 commons-pool-tomcat5)        
ant     -f dbcp-tomcat5-build.xml

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
%if %with maven
install -m 644 target/%{short_name}-%{version}-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%else
install -m 644 dist/%{short_name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%endif
#tomcat5 jars 
install -m 644 dbcp-tomcat5/%{short_name}-tomcat5.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-tomcat5-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|apache-||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %with maven
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rm -rf target/site/apidocs
%else
cp -pr dist/docs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p LICENSE.txt NOTICE.txt README.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%if %with maven
# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%endif

# hibernate_jdbc_cache ghost symlink
touch $RPM_BUILD_ROOT%{_javadir}/hibernate_jdbc_cache.jar

# Install pom file
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
cp -p pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-apache-commons-dbcp.pom
%add_to_maven_depmap commons-dbcp commons-dbcp %{version} JPP apache-commons-dbcp

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__install} -p -m 0644 %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__sed} -i "s/@VERSION@/%{version}-brew/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__install} -p -m 0644 %{SOURCE0} %{buildroot}%{repodirsrc}/
%{__install} -p -m 0644 %{SOURCE1} %{buildroot}%{repodirsrc}/
%{__install} -p -m 0644 %{SOURCE2} %{buildroot}%{repodirsrc}/
%{__install} -p -m 0644 %{SOURCE3} %{buildroot}%{repodirsrc}/
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/%{short_name}.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
update-alternatives --install %{_javadir}/hibernate_jdbc_cache.jar \
  hibernate_jdbc_cache %{_javadir}/%{name}.jar 60
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%preun
{
  [ $1 -eq 0 ] || exit 0
  update-alternatives --remove hibernate_jdbc_cache %{_javadir}/%{name}.jar
} >/dev/null 2>&1 || :

%if %{gcj_support}
%post tomcat5
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun tomcat5
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root)
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{short_name}.jar
%{_javadir}/%{short_name}-%{version}.jar
%ghost %{_javadir}/hibernate_jdbc_cache.jar
%dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/*.txt
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files tomcat5
%defattr(-,root,root)
%{_javadir}/*-tomcat5*.jar
%doc LICENSE.txt NOTICE.txt

%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*-tomcat5*
%endif

%files javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%if %with maven
%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/site
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Sun Nov 22 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.3.0-0.r830852.1
- 1.3.0
- rename to apache-commons-dbcp
- build with maven2 by default

* Tue Apr 30 2009 Yong Yang <yyang@redhat.com> - 0:1.2.1-16
- Rebuild with maven2-2.0.8 built in non-bootstrap mode

* Wed Mar 18 2009 Yong Yang <yyang@redhat.com> - 0:1.2.1-15
- rebuild with new maven2 2.0.8 built in bootstrap mode

* Thu Feb 05 2009 Yong Yang <yyang@redhat.com> - 0:1.2.1-14
- Fix release tag
- BR plexus-containers-component-api explicitly 

* Thu Jan 15 2009 Yong Yang <yyang@redhat.com> - 0:1.2.1-13jpp.4 
- re-build with maven
- Disabled manual subpackage, because maven failed to run xdoc:transform

* Fri Jan 09 2009 Yong Yang <yyang@redhat.com> - 0:1.2.1-12jpp.4
- Imported from dbhole's maven 2.0.8 packages
- Add jdk6 patch

* Thu Apr 10 2008 Deepak Bhole <dbhole@redhat.com> - 0:1.2.1-11jpp.4
- Update to 1.2.2
- Add a pom file for the project

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0:1.2.1-11jpp.3
- Autorebuild for GCC 4.3

* Thu Nov 22 2007 Deepak Bhole <dbhole@redhat.com> 0:1.2.1-10jpp.3
- Fix dangling symlink. bz#388801

* Thu Sep 20 2007 Deepak Bhole <dbhole@redhat.com> 0:1.2.1-10jpp.2
- Rebuild

* Mon Mar 12 2007 Matt Wringe <mwringe@redhat.com> 0:1.2.1-10jpp.1
- Merger with newest jpp version
- Fix rpmlint issues
- Disable testThreaded for now as it will sometimes fail

* Fri Feb 23 2007 Jason Corley <jason.corley@gmail.com> 0:1.2.1-10jpp
- update copyright to contain current year
- rebuild on RHEL4 to avoid broken jar repack script in FC6

* Fri Jan 26 2007 Matt Wringe <mwringe@redhat.com> 0:1.2.1-9jpp
- Fix bug in dbcp-tomcat5-build.xml

* Mon Jan 22 2007 Matt Wringe <mwringe@redhat.com> 0:1.2.1-8jpp
- Add tomcat5 subpackage
- Add versioning to provides and obsoletes
- Move rm -rf %%RPM_BUILD_ROOT from %%prep to %%install
- Add missing maven plugin dependencies

* Thu Aug 17 2006 Deepak Bhole <dbhole@redhat.com> 0:1.2.1-7jpp.1
- Added missing postun section.

* Thu Aug 10 2006 Deepak Bhole <dbhole@redhat.com> 0:1.2.1-6jpp.1
- Added missing requirements.

* Thu Aug 10 2006 Karsten Hopp <karsten@redhat.de> 1.2.1-5jpp_4fc
- Requires(post/postun): coreutils

* Sat Jul 22 2006 Jakub Jelinek <jakub@redhat.com> 0:1.2.1-5jpp_3fc
- Rebuilt

* Thu Jul 20 2006 Deepak Bhole <dbhole@redhat.com> 0:1.2.1-5jpp_2fc
- Rebuild.

* Thu Jul 20 2006 Deepak Bhole <dbhole@redhat.com> 0:1.2.1-5jpp_1fc
- Added conditional native compilation.

* Wed Apr 12 2006 Ralph Apel <r.apel@r-apel.de> - 0:1.2.1-4jpp
- First JPP-1.7 release
- Build with maven by default
- Add option to build with straight ant
- Add -manual subpackage when built with maven
- Backported TestJOCLed from HEAD

* Tue Nov 02 2004 Fernando Nasser <fnasser@redhat.com> - 0:1.2.1-3jpp
- Bump release to make provide hibernate_jdbc_cache official

* Tue Aug 24 2004 Randy Watler <rwatler at finali.com> - 0:1.2.1-0.hjc.2jpp
- Rebuild with ant-1.6.2

* Fri Jul 02 2004 Ralph Apel <r.apel at r-apel.de> 0:1.2.1-0.hjc.1jpp
- Provide hibernate_jdbc_cache and di update-alternatives, prio 60

* Thu Jun 24 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:1.2.1-1jpp
- Update to 1.2.1 (tomcat 5.0.27 wants it)

* Mon Oct 27 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.1-1jpp
- common-dbcp 1.1

* Tue Mar 25 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 1.0-4jpp
- for jpackage-utils 1.5

* Thu Feb 27 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.0-3jpp
- fix ASF license

* Thu Feb 27 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.0-2jpp
- fix missing packager tag

* Fri Aug 23 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0-1jpp
- 1.0 release

* Fri Jul 12 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0-3jpp
- add require xml-commons-apis
- override java.io.tmpdir to avoid build use /tmp

* Mon Jun 10 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0-2jpp
- use sed instead of bash 2.x extension in link area to make spec compatible
  with distro using bash 1.1x

* Fri Jun 07 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0-1jpp 
- 1.0 (cvs 20020606)
- added short names in %%{_javadir}, as does jakarta developpers
- first jPackage release
